
from Image import Image
from ODEObject import ODEObject

from util import *
from constants import *

import ode
import math 
import random


class  Balloon(ODEObject):

    def __init__(self,world,space,list, pos=(-1,1), radius=.1, image = 'ball', static_color = False):
        mass = ode.Mass()
        mass.setSphere(10,radius)
        
        if not static_color:
            red = random.random()
            green = random.random()
            blue = random.random()
            color = (red,green,blue,1)
        else:
            color = (1,1,1,1)
        
        ODEObject.__init__(self,world,space,list,ode.GeomSphere(space, radius), mass, pos=pos,image=image, color = color)

        self.width= PIXELS_PER_METER*radius*2
        self.height = PIXELS_PER_METER*radius*2

        self.shape = 'ball'
        self.radius = radius



    def update(self):
        self.body.addForce((0,5,0))
