
from Image import Image
from ODEObject import ODEObject

import ode
import math 

from constants import *
from util import *


class  Block(ODEObject):

    def __init__(self,world,space,list, pos=(0,0), size = (.1,.2,.1), color=(1,1,1,1), angle=0):
        # Define the mass setup
        mass = ode.Mass()
        mass.setBox(800, size[0], size[1], size[2])

        ODEObject.__init__(self,world,space,list,ode.GeomBox(space, size), mass,pos=pos, image='blank', color = color)
        
        # Define the Geometry
        self.shape = 'box'
        self.boxsize = size
        
        self.height = size[1] * PIXELS_PER_METER
        self.width = size[0] * PIXELS_PER_METER
        self.body.setRotation(rotMatrix(angle))

        self.fixedJoint = ode.FixedJoint(world)
        self.fixedJoint.attach(self.body,ode.environment)
        self.fixedJoint.setFixed()
