
import ode
from constants import *
from util import *

import pygame
from pygame.locals import *

from Balloon import Balloon
from Box import Box
from JayBalloon import JayBalloon
from Spinner import Spinner
from Block import Block

levelCount = 7
songlist = []

class Levels:
    def __init__(self, level=1):
        """"""
        self.level = level
        songlist.append("data/Z.ogg")
        songlist.append("data/battle.ogg")
        self.last_level = 0

    def createLevel(self,level=None):
        if not level:
            level = self.level
        else:
            self.level = level

        self.sandBox = False
        self.levelText = []

        self.world, self.space = self.buildObjects()
        self.object_list = []

        if self.level == 1:
            player = JayBalloon(self.world, self.space, self.object_list, pos=(2,.96))
            self.levelText = ["The only way is up"]


        if self.level == 2:
            self.levelText = ["Spinner"]
            player = JayBalloon(self.world, self.space, self.object_list, pos=(2,.96))

            block1 = Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,inv_coord(0,WORLD_HEIGHT)[1]), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))

            spinner = Spinner(self.world,self.space,self.object_list, pos=(6,6), size=(2,.1,1))

        if self.level == 3:
            self.levelText = ["Break Out"]
            player = JayBalloon(self.world, self.space, self.object_list, pos=(4,.96))

            Box(self.world,self.space,self.object_list, pos=(3.3,.8+.1),size=(.1,1.5,.1))
            Box(self.world,self.space,self.object_list, pos=(3.3,2.4+.2),size=(.1,1.5,.1))
            Box(self.world,self.space,self.object_list, pos=(4.7,.8+.1),size=(.1,1.5,.1))
            Box(self.world,self.space,self.object_list, pos=(4.7,2.4+.2),size=(.1,1.5,.1))
            Box(self.world,self.space,self.object_list, pos=(3.3,3.1+.3),size=(1.24,.1,.1))
            Box(self.world,self.space,self.object_list, pos=(4.7,3.1+.3),size=(1.24,.1,.1))

        if self.level == 4:
            self.levelText = ["Traversal"]
            player = JayBalloon(self.world, self.space, self.object_list, pos=(4,.96))

            player.fuel *= 2

            Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,inv_coord(0,WORLD_HEIGHT)[1]), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))

            Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,3.5), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))

            Block(self.world,self.space,self.object_list, pos=(.1+1.5+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,7), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))
            
            Spinner(self.world,self.space,self.object_list, pos=(1.3,.9), size=(.7,.1,1))
            Spinner(self.world,self.space,self.object_list, pos=(9.4,5.9), size=(.7,.1,1),reverse=True)
            Spinner(self.world,self.space,self.object_list, pos=(1.3,9), size=(.7,.1,1))

            for i in range(8):
                Balloon(self.world,self.space,self.object_list, pos=(2, .1 + .3 * i),radius=.15)

            for i in range(8):
                Balloon(self.world,self.space,self.object_list, pos=(6, .1 + .3 * i),radius=.15)

        if self.level == 5:
            self.levelText = ["The only way is","down?"]
            player = JayBalloon(self.world, self.space, self.object_list, pos=(2,8.5))
            player.fuel *= 1.5

            Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,inv_coord(0,WORLD_HEIGHT)[1]), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))
            Block(self.world,self.space,self.object_list, pos=(2.5, 7), size=(3,.5,.1), color=(.3,.6,1,1))
            Block(self.world,self.space,self.object_list, pos=(6, 6), size=(.5,6,.1), color=(.3,.6,1,1))


        if self.level == 6:
            self.levelText = ["The Gauntlet"]
            player = JayBalloon(self.world, self.space, self.object_list, pos=(5.03,.96))

            Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/4.0,inv_coord(0,WORLD_HEIGHT)[1]), size=((inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,.5,.1), color=(.3,.6,1,1))
            Block(self.world,self.space,self.object_list, pos=(7.875,inv_coord(0,WORLD_HEIGHT)[1]), size=((inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,.5,.1), color=(.3,.6,1,1))

            Spinner(self.world,self.space,self.object_list, pos=(8.2,5.6), size=(2.5,.1,1))
            Spinner(self.world,self.space,self.object_list, pos=(3.6,5.6), size=(2.5,.1,1),reverse=True)

        elif self.level == 7:
            self.levelText = ["You win!","Congratulations!"]
            player = JayBalloon(self.world,self.space, self.object_list, pos=(4,2)) 
            player.fuel = player.maxFuel
            self.sandBox = True
            ball = Balloon(self.world,self.space, self.object_list, pos=(.5,3))
            box1 = Box(self.world,self.space,self.object_list, pos=(1,1))
            box2 = Box(self.world,self.space,self.object_list, pos=(1,2))
            box3 = Box(self.world,self.space,self.object_list, pos=(2,2), size=(.1,.1,.1), color=(.3,.6,1,1))
            block = Block(self.world,self.space,self.object_list, pos=(.1+(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5)/2.0,inv_coord(0,WORLD_HEIGHT)[1]), size=(inv_coord(WORLD_WIDTH,0)[0]-0.2-1.5,.5,.1), color=(.3,.6,1,1))
            block = Block(self.world,self.space,self.object_list, pos=(4,3), size=(3,.1,1), angle=30)
            spinner = Spinner(self.world,self.space,self.object_list, pos=(6,6), size=(1,.1,1))
            spinner2 = Spinner(self.world,self.space,self.object_list, pos=(7,1.5), size=(1,.1,1))


        if self.last_level != self.level:
            song = songlist[self.level % len(songlist)]
            pygame.mixer.music.load(song)
            pygame.mixer.music.set_volume(MUSIC_VOLUME)
            pygame.mixer.music.play(-1)
        
        self.last_level = self.level
        
        return self.world, self.space, self.object_list, player

    def levelUp(self):
        if self.level < levelCount:
            self.level += 1
        else:
            self.level = 1

    def buildObjects(self):
        world = ode.World()
        world.setGravity((0,-9.81,0))
        space = ode.Space()
        floor = ode.GeomPlane(space, (0,1,0), 0.1)
        rwall = ode.GeomPlane(space, (-1,0,0), -1*inv_coord(WORLD_WIDTH,0)[0] +0.1 )
        lwall = ode.GeomPlane(space, (1,0,0), 0.1)

        return world, space

