from Image import Image
import ode
import math 

from constants import *
from util import *


def rot(body):
    return math.degrees(math.acos(body.getRotation()[0]))


class  ODEObject:

    def __init__(self,world,space,list, geom, mass, image='cow', pos=(0,0), color = (1,1,1,1)):
        self.image = Image(image)
        loc = (pos[0],pos[1],0)
        

        
        self.world = world
        self.color = color

        self.body = ode.Body(world)
        self.geom = geom
        self.geom.setBody(self.body)

        self.mass = mass

        self.body.setMass(self.mass)
        self.body.setPosition(loc)

        self.join2d = ode.Plane2DJoint(world)
        self.join2d.attach(self.body, ode.environment)

        list.append(self)

    def align(self):
        
        rot = self.body.getAngularVel()
        quat = self.body.getQuaternion()
        newQuat = []
        newQuat[:] = quat[:]
        newQuat[1] = 0
        newQuat[2] = 0

        quatLen = math.sqrt( quat[0] * quat[0] + quat[3] * quat[3] )
        newQuat[0] /= quatLen
        newQuat[1] /= quatLen
        self.body.setQuaternion(newQuat)
        self.body.setAngularVel((0,0,rot[2]))

    def draw(self):
        x1,y1,z1 = self.body.getPosition()
        c1,c2 = coord(x1,y1)
        self.image.draw(pos=(c1-self.width/2,c2-self.height/2), width=self.width,height=self.height,rotMatrix=self.body.getRotation(), color=self.color)

    def update(self):
        pass
